"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emit = void 0;
const ArrayUtils = require("../utils/array_utils");
const Delimiters = require("./delimiters");
const Parentheses = require("./parentheses");
/**
 * Emits tokens for an array of method arguments including parenthesis.
 * @param _arguments An array of arguments to emit into tokens.
 */
function emit(_arguments) {
    return Parentheses.enclose(...precursors(_arguments));
}
exports.emit = emit;
function precursors(_arguments) {
    if (ArrayUtils.isFalsy(_arguments))
        return ArrayUtils.empty();
    else
        return Delimiters.commaSeparated(..._arguments.map(x => [x]));
}
