"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emit = void 0;
const ArrayUtils = require("../utils/array_utils");
const Delimiters = require("./delimiters");
const TypeReferenceTokens = require("./type_reference_tokens");
const Parentheses = require("./parentheses");
function emit(parameters) {
    const parameterTokens = ArrayUtils.isFalsy(parameters) ? ArrayUtils.empty() : precursors(parameters);
    return Parentheses.enclose(...parameterTokens);
}
exports.emit = emit;
function precursors(parameters) {
    return Delimiters.commaSeparated(...parameters.map(p => precursor(p)));
}
function precursor(parameter) {
    const { type, name } = parameter;
    return [...TypeReferenceTokens.emit(type), Delimiters.space, name];
}
